VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "www.activevb.de"
   ClientHeight    =   3255
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4965
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3255
   ScaleWidth      =   4965
   StartUpPosition =   2  'Bildschirmmitte
   Begin VB.Frame Frame1 
      Caption         =   "Sample Rate"
      Height          =   1245
      Left            =   3000
      TabIndex        =   7
      Top             =   75
      Width           =   1875
      Begin VB.OptionButton optSample 
         Caption         =   "44100"
         Height          =   240
         Index           =   2
         Left            =   270
         TabIndex        =   10
         Top             =   915
         Value           =   -1  'True
         Width           =   1230
      End
      Begin VB.OptionButton optSample 
         Caption         =   "22050"
         Height          =   240
         Index           =   1
         Left            =   270
         TabIndex        =   9
         Top             =   615
         Width           =   1230
      End
      Begin VB.OptionButton optSample 
         Caption         =   "11025"
         Height          =   240
         Index           =   0
         Left            =   270
         TabIndex        =   8
         Top             =   300
         Width           =   1230
      End
   End
   Begin VB.Frame frmStereo 
      Caption         =   "Mono/Stereo"
      Height          =   1695
      Left            =   3000
      TabIndex        =   2
      Top             =   1440
      Width           =   1860
      Begin VB.OptionButton optWavtype 
         Caption         =   "16 Bit Stereo"
         Height          =   195
         Index           =   3
         Left            =   195
         TabIndex        =   6
         Top             =   1290
         Value           =   -1  'True
         Width           =   1335
      End
      Begin VB.OptionButton optWavtype 
         Caption         =   "16 Bit Mono"
         Height          =   195
         Index           =   2
         Left            =   210
         TabIndex        =   5
         Top             =   960
         Width           =   1335
      End
      Begin VB.OptionButton optWavtype 
         Caption         =   "8 Bit Stereo"
         Height          =   195
         Index           =   1
         Left            =   195
         TabIndex        =   4
         Top             =   630
         Width           =   1335
      End
      Begin VB.OptionButton optWavtype 
         Caption         =   "8 Bit Mono"
         Height          =   195
         Index           =   0
         Left            =   195
         TabIndex        =   3
         Top             =   315
         Width           =   1335
      End
   End
   Begin VB.ListBox lstDevice 
      Height          =   2595
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   2805
   End
   Begin VB.CommandButton cmdGet 
      Caption         =   "Get Caps"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   2760
      Width           =   2790
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

'Autor: Klaus Langbein
'E-Mail: Klaus@ActiveVB.de

'Dieses Programm wurde auf der Grundlage der Vorarbeiten von
'Murphy McCauley erstellt.

'-------------------------------------------------------------
' Murphy McCauley (MurphyMc@Concentric.NET) 08/14/99
' http://www.fullspectrum.com/deeth/
'-------------------------------------------------------------

Option Explicit

Private Declare Function waveOutGetDevCaps Lib "winmm.dll" _
        Alias "waveOutGetDevCapsA" (ByVal uDeviceID As Long, _
        lpCaps As WaveOutCaps, ByVal uSize As Long) As Long
                
Private Declare Function waveOutGetNumDevs Lib "winmm.dll" _
        () As Long

Private Type WaveOutCaps
    ManufacturerID As Integer
    ProductID As Integer
    DriverVersion As Long
    ProductName(1 To 32) As Byte
    Formats As Long
    Channels As Integer
    dwSupport As Long
End Type

Const WAVE_INVALIDFORMAT As Long = &H0& 'invalid format
Const WAVE_FORMAT_1M08 As Long = &H1&   '11.025 kHz,Mono,   8-bit
Const WAVE_FORMAT_1S08 As Long = &H2&   '11.025 kHz,Stereo, 8-bit
Const WAVE_FORMAT_1M16 As Long = &H4&   '11.025 kHz,Mono,  16-bit
Const WAVE_FORMAT_1S16 As Long = &H8&   '11.025 kHz,Stereo,16-bit
Const WAVE_FORMAT_2M08 As Long = &H10&  '22.05  kHz,Mono,   8-bit
Const WAVE_FORMAT_2S08 As Long = &H20&  '22.05  kHz,Stereo, 8-bit
Const WAVE_FORMAT_2M16 As Long = &H40&  '22.05  kHz,Mono,  16-bit
Const WAVE_FORMAT_2S16 As Long = &H80&  '22.05  kHz,Stereo,16-bit
Const WAVE_FORMAT_4M08 As Long = &H100& '44.1   kHz,Mono,   8-bit
Const WAVE_FORMAT_4S08 As Long = &H200& '44.1   kHz,Stereo, 8-bit
Const WAVE_FORMAT_4M16 As Long = &H400& '44.1   kHz,Mono,  16-bit
Const WAVE_FORMAT_4S16 As Long = &H800& '44.1   kHz,Stereo,16-bit
              
Private Function getOptionWavetype() As Long
    Dim i As Integer
    
    For i = 0 To 3
        If optWavtype(i).Value = -1 Then
            getOptionWavetype = i
            Exit Function
        End If
    Next i
End Function

Private Function getSampleRate() As Long
    Dim i As Integer
    
    For i = 0 To 2
        If optSample(i).Value = -1 Then
            getSampleRate = Val(optSample(i).Caption)
            Exit Function
        End If
    Next i
End Function

Private Sub cmdGet_Click()
    Dim wavetype As Long
    Dim wtype As Long
    Dim Srate As Long
    
    lstDevice.Clear
    wtype = getOptionWavetype
    Srate = getSampleRate
      
    Select Case Srate
        Case 11025
            Select Case wtype
                Case 0: wavetype = WAVE_FORMAT_1M08
                Case 1: wavetype = WAVE_FORMAT_1S08
                Case 2: wavetype = WAVE_FORMAT_1M16
                Case 3: wavetype = WAVE_FORMAT_1S16
            End Select
            
        Case 22050
            Select Case wtype
                Case 0: wavetype = WAVE_FORMAT_2M08
                Case 1: wavetype = WAVE_FORMAT_2S08
                Case 2: wavetype = WAVE_FORMAT_2M16
                Case 3: wavetype = WAVE_FORMAT_2S16
            End Select
            
        Case 44100
            Select Case wtype
                Case 0: wavetype = WAVE_FORMAT_4M08
                Case 1: wavetype = WAVE_FORMAT_4S08
                Case 2: wavetype = WAVE_FORMAT_4M16
                Case 3: wavetype = WAVE_FORMAT_4S16
            End Select
        End Select
        
        Call FindCompatibleDevice(wavetype)
End Sub

Private Sub FindCompatibleDevice(DeviceFormat As Long)
    Dim Caps As WaveOutCaps
    Dim Device As Long
    
    For Device = 0 To waveOutGetNumDevs - 1
        Call waveOutGetDevCaps(Device, Caps, Len(Caps))
        
        If (Caps.Formats And DeviceFormat) Then
            lstDevice.AddItem StrConv(Caps.ProductName, vbUnicode)
        End If
    Next Device
End Sub
